TUCAN SERVICE HOWTO
-------------------

Indice:
 1 - IntroducciÃ³n
 2 - Breve resumen
 3 - Secciones
 3.1 - Directorio de servicio (obligatorio)
 3.2 - Archivo __init__.py (obligatorio)
 3.3 - Archivo service.conf (obligatorio)
 3.4 - Archivo imagen o icono (opcional)
 3.5 - Archivo check_links.py (opcional)
 3.6 - Archivo anonymous_download.py (opcional)
 3.7 - Archivo premium.accounts (opcional)
 3.8 - Archivo premium_downloads.py (opcional)
 3.9 - Archivo premium_cookie.py (opcional)


1 - IntroducciÃ³n
----------------
En este documento se van a explicar las lineas generales para implementar un
nuevo servicio para Tucan (archivos mÃ­nimos, ubicaciÃ³n de esos archivos,
formato, parÃ³metros de entrada/salida... etc).


2 - Breve resumen
-----------------
servicio/             : obligatorio: Directorio que contiene todos los
                                     archivos del servicio, no puede contener
                                     ningÃºn punto "." en el nombre.

__init__.py           : obligatorio: Necesario para que python reconozca el
                                     directorio como mÃ³dulo.

service.conf          : obligatorio: DescripciÃ³n e informaciÃ³n del servicio
                                     para que el sistema de plugins sepa que
                                     soporta este servicio.

<imagen o icono>      : opcional: Imagen o icono de tamaÃ±o 48x48 pixels
                                  representativo del servicio.

check_links.py        : opcional: SÃ³lo necesario si el servicio tiene soporte
                                  para descargas. Puede ser un archivo o puede
                                  ser un metodo de un plugin de descarga.

anonymous_download.py : opcional: SÃ³lo necesario si el servicio tiene soporte
                                  para descargas anÃ³nimas.

premium.accounts      : opcional: SÃ³lo necesario si el servicio tiene soporte
                                  para cuentas premium (se genera desde el GUI).

premium_download.py   : opcional: SÃ³lo necesario si el servicio tiene soporte
                                  para descargas premium.

premium_cookie.py     : opcional: SÃ³lo necesario si el servicio tiene soporte
                                  para descargas premium.


3 - Secciones
-------------

3.1 - Directorio de Servicio (obligatorio)
------------------------------------------
El directorio contendrÃ¡ todos los archivos de los diferentes plugins del
servicio, no debe contener ningÃºn punto "." en el nombre. Ejemplos:

   http://rapidshare.com  ->  rapidshare/
   http://megaupload.com  ->  megaupload/
   http://gigasize.com    ->  gigasize/
   http://foobar.com      ->  foobar/


3.2 - Archivo __init__.py (obligatorio)
---------------------------------------
Este archivo es necesario para que python reconozca el directorio como mÃ³dulo.
Es un archivo vacio.


3.3 - Archivo service.conf (obligatorio)
----------------------------------------
Este archivo describe y da informaciÃ³n de los distintos plugins al sistema de
plugins de Tucan para que conozca las funcionalidades del servicio.

Consta de varias secciones:

   [main]
   enabled = False
   name = rapidshare.com
   icon = rapidshare.png
   premium_cookie = PremiumCookie
   downloads = True
   uploads = False
   update = 200904180200

   [anonymous_download]
   name = AnonymousDownload
   author = Crak
   captcha = True
   version = 0.3
   slots = 1

   [premium_download]
   name = PremiumDownload
   author = Crak
   version = 0.2
   accounts = premium.accounts


SecciÃ³n [main]:
"enabled"        : OpciÃ³n para notificar que el servicio esta activado o
                   desactivado. Valores: True, False. Por defecto estarÃ¡
                   desactivado (el usuario debe activar el servicio en la
                   ventana preferencias antes de poder usarlo).
"name"           : OpciÃ³n para notificar el nombre del servicio.
                   Ejemplos: rapidshare.com, megaupload.com, gigasize.com
"icon"           : OpciÃ³n para notificar el nombre del icono o imagen
                   representativa del servicio que se va a usar en el GUI.
                   Opcional: si no se va a usar se debe poner None.
"downloads"      : OpciÃ³n para notificar que el servicio puede realizar
                   descargas. Valores: True, False.
"premium_cookie" : OpciÃ³n para notificar el nombre de la clase que se va a
                   usar para gestionar la cookie necesaria en las cuentas
                   premium.
"uploads"        : OpciÃ³n para notificar que el servicio puede realizar
                   subidas. Valores: True, False.
"update"         : Opcion para la actualizaciÃ³n automÃ¡tica del servicio, serÃ¡ un
                   nÃºmero a incrementar cuando se quiera actualizar el servicio.
                   Valores: int (preferiblemente en formato YYYYMMDDHHMM).


SecciÃ³n [anonymous_download]:
"name"    : OpciÃ³n para notificar el nombre de la clase que se va a usar para
            realizar este tipo de acceso.
            Valor por defecto: AnonymousDownload.
"author"  : OpciÃ³n para notificar el nombre (o nick o email) del creador.
"captcha" : OpciÃ³n para notificar si el servicio tiene captcha en las
            descargas anÃ³nimas. Valores: True, False.
"version" : VersiÃ³n del plugin.
"slots"   : NÃºmero mÃ¡ximo de descargas simultaneas permitidas por este servicio.
            Valores: int (Ã³ "Unlimited" para los servicios que no implementan
                          la clase slots).


SecciÃ³n [premium_download]:
"name"     : OpciÃ³n para notificar el nombre de la clase que se va a usar para
             realizar este tipo de acceso.
             Valor por defecto: PremiumDownload.
"author"   : OpciÃ³n para notificar el nombre (o nick o email) del creador.
"version"  : VersiÃ³n del plugin.
"accounts" : Nombre del archivo donde se van a almacenar los datos de las
             cuentas premium de este servicio.


3.4 - Archivo imagen o icono (opcional)
---------------------------------------
Imagen o icono de tamaÃ±o 48x48 pixels representativo del servicio que se va a
usar en el GUI.
Si no se va a usar se debe notificar en el archivo service.conf, secciÃ³n [main]
opciÃ³n "icon = None".


3.5 - Archivo check_links.py (opcional)
---------------------------------------
Este archivo sÃ³lo es necesario si el servicio tiene soporte para descargas.
Puede ser un archivo si lo usan varios plugins (descargas anÃ³nimas, descargas
premium) o puede ser un metodo de los distintos plugins de descarga.

parÃ¡metros de entrada: url.
parÃ¡metros de salida: nombre del archivo a descargar, tamaÃ±o y unidades.

    comprobaciones/tareas mÃ­nimas:
        url activa
        determinar nombre del archivo y tamaÃ±o total.


3.6 - Archivo anonymous_download.py (opcional)
----------------------------------------------
Este archivo sÃ³lo es necesario si el servicio tiene soporte para descargas
anÃ³nimas. Plugin tÃ­pico.

clases: AnonymousDownload (declarada en el archivo service.conf, secciÃ³n
                          [anonymous_download])
mÃ©todos:
  __init__: inicializaciÃ³n de slots.py y download_plugin.py
  add: parÃ¡metros de entrada: ruta, link y nombre del archivo
  delete: parÃ¡metros de entrada: nombre del archivo.
  check_links: parÃ¡metros de entrada: url. parÃ¡metros de salida: nombre del
  archivo a descargar, tamaÃ±o y unidades.


3.7 - Archivo premium.accounts (opcional)
-----------------------------------------
Este archivo sÃ³lo es necesario si el servicio tiene soporte para cuentas
premium.
Se genera desde el GUI (preferencias) y esta cifrado.


3.8 - Archivo premium_downloads.py (opcional)
---------------------------------------------
Este archivo sÃ³lo es necesario si el servicio tiene soporte para descargas
Premium. Plugin tÃ­pico.

clases: PremiumDownload (declarada en el archivo service.conf, secciÃ³n
                          [premium_download])
mÃ©todos:
  __init__: inicializaciÃ³n de accounts.py
  add: parÃ¡metros de entrada: ruta, link y nombre del archivo
  delete: parÃ¡metros de entrada: nombre del archivo
  check_links: parÃ¡metros de entrada: url. parÃ¡metros de salida: nombre del
  archivo a descargar, tamaÃ±o y unidades.


3.9 - Archivo premium_cookie.py (opcional)
------------------------------------------
Este archivo sÃ³lo es necesario si el servicio tiene soporte para cuentas
Premium.

clases: PremiumCookie (declarada en el archivo service.conf, secciÃ³n
                        [main])
mÃ©todos:
  get_cookie: parÃ¡metros de entrada: user, password url.
  parÃ¡metros de salida: cookie (cookielib.CookieJar).
